import * as i0 from '@angular/core';
import { Injectable, Directive, Host, Input, HostBinding, inject, TemplateRef, Component, ViewChild, ContentChild, NgModule } from '@angular/core';
import * as i3 from '@ng-bootstrap/ng-bootstrap';
import { NgbPopover } from '@ng-bootstrap/ng-bootstrap';
import { firstValueFrom } from 'rxjs';
import { TourService, TourHotkeyListenerComponent } from 'ngx-ui-tour-core';
import { NgIf } from '@angular/common';

class NgbTourService extends TourService {
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.1", ngImport: i0, type: NgbTourService, deps: null, target: i0.ɵɵFactoryTarget.Injectable }); }
    static { this.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "16.1.1", ngImport: i0, type: NgbTourService, providedIn: 'root' }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.1", ngImport: i0, type: NgbTourService, decorators: [{
            type: Injectable,
            args: [{
                    providedIn: 'root',
                }]
        }] });

class TourStepTemplateService {
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.1", ngImport: i0, type: TourStepTemplateService, deps: [], target: i0.ɵɵFactoryTarget.Injectable }); }
    static { this.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "16.1.1", ngImport: i0, type: TourStepTemplateService, providedIn: 'root' }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.1", ngImport: i0, type: TourStepTemplateService, decorators: [{
            type: Injectable,
            args: [{
                    providedIn: 'root'
                }]
        }] });

class TourAnchorNgBootstrapDirective {
    constructor(tourService, tourStepTemplate, element, popoverDirective) {
        this.tourService = tourService;
        this.tourStepTemplate = tourStepTemplate;
        this.element = element;
        this.popoverDirective = popoverDirective;
        this.popoverDirective.autoClose = false;
        this.popoverDirective.triggers = '';
        // eslint-disable-next-line @typescript-eslint/no-empty-function
        this.popoverDirective.toggle = () => { };
    }
    ngOnInit() {
        this.tourService.register(this.tourAnchor, this);
    }
    ngOnDestroy() {
        this.tourService.unregister(this.tourAnchor);
    }
    // noinspection JSUnusedGlobalSymbols
    async showTourStep(step) {
        if (this.popoverDirective.isOpen()) {
            await firstValueFrom(this.popoverDirective.hidden);
        }
        this.isActive = true;
        this.popoverDirective.ngbPopover = this.tourStepTemplate.template;
        if (step.useLegacyTitle) {
            this.popoverDirective.popoverTitle = step.title;
        }
        this.popoverDirective.container = 'body';
        const popoverClass = step.popoverClass ?? '';
        this.popoverDirective.popoverClass = `tour-step ${popoverClass}`;
        this.popoverDirective.placement = (step.placement || 'auto')
            .replace('before', 'left').replace('after', 'right')
            .replace('below', 'bottom').replace('above', 'top');
        const offset = step.backdropConfig?.offset;
        if (offset) {
            this.popoverDirective.popperOptions = options => this.setOffsetModifier(options, offset);
        }
        this.popoverDirective.open({ step });
    }
    setOffsetModifier(options, offset) {
        const offsetModifier = options.modifiers
            ?.find(modifier => modifier.name === 'offset' && modifier.options), arrowHeight = 10;
        if (offsetModifier) {
            offsetModifier.options.offset = [0, offset + arrowHeight];
        }
        return options;
    }
    // noinspection JSUnusedGlobalSymbols
    hideTourStep() {
        this.isActive = false;
        this.popoverDirective.close();
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.1", ngImport: i0, type: TourAnchorNgBootstrapDirective, deps: [{ token: NgbTourService }, { token: TourStepTemplateService }, { token: i0.ElementRef }, { token: i3.NgbPopover, host: true }], target: i0.ɵɵFactoryTarget.Directive }); }
    static { this.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "14.0.0", version: "16.1.1", type: TourAnchorNgBootstrapDirective, isStandalone: true, selector: "[tourAnchor]", inputs: { tourAnchor: "tourAnchor" }, host: { properties: { "class.touranchor--is-active": "this.isActive" } }, hostDirectives: [{ directive: i3.NgbPopover }], ngImport: i0 }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.1", ngImport: i0, type: TourAnchorNgBootstrapDirective, decorators: [{
            type: Directive,
            args: [{
                    selector: '[tourAnchor]',
                    standalone: true,
                    hostDirectives: [NgbPopover]
                }]
        }], ctorParameters: function () { return [{ type: NgbTourService }, { type: TourStepTemplateService }, { type: i0.ElementRef }, { type: i3.NgbPopover, decorators: [{
                    type: Host
                }] }]; }, propDecorators: { tourAnchor: [{
                type: Input
            }], isActive: [{
                type: HostBinding,
                args: ['class.touranchor--is-active']
            }] } });

class TourStepTemplateComponent extends TourHotkeyListenerComponent {
    constructor() {
        super(...arguments);
        this.tourStepTemplateService = inject(TourStepTemplateService);
        this.tourService = inject(NgbTourService);
    }
    ngAfterContentInit() {
        this.tourStepTemplateService.template =
            this.stepTemplate ||
                this.stepTemplateContent ||
                this.defaultTourStepTemplate;
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.1", ngImport: i0, type: TourStepTemplateComponent, deps: null, target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.1.1", type: TourStepTemplateComponent, isStandalone: true, selector: "tour-step-template", inputs: { stepTemplate: "stepTemplate" }, queries: [{ propertyName: "stepTemplateContent", first: true, predicate: TemplateRef, descendants: true }], viewQueries: [{ propertyName: "defaultTourStepTemplate", first: true, predicate: ["tourStep"], descendants: true, read: TemplateRef, static: true }], usesInheritance: true, ngImport: i0, template: "<ng-template #tourStep let-step=\"step\">\n    <div\n        [style.width]=\"step.stepDimensions?.width\"\n        [style.min-width]=\"step.stepDimensions?.minWidth\"\n        [style.max-width]=\"step.stepDimensions?.maxWidth\"\n        class=\"main-container\"\n    >\n        <div\n            *ngIf=\"!step?.useLegacyTitle && step?.title\"\n            class=\"title-container\"\n        >\n            <h5>{{step?.title}}</h5>\n            <button\n                type=\"button\"\n                class=\"btn-close\"\n                aria-label=\"Close\"\n                (click)=\"tourService.end()\"\n            ></button>\n        </div>\n\n        <p\n            class=\"card-text\"\n            [innerHTML]=\"step?.content\"\n        ></p>\n\n        <div class=\"buttons\">\n            <button\n                [disabled]=\"!tourService.hasPrev(step)\"\n                class=\"btn btn-sm btn-outline-secondary prev\"\n                (click)=\"tourService.prev()\"\n            >\n                <svg xmlns=\"http://www.w3.org/2000/svg\" width=\"16\" height=\"16\" fill=\"currentColor\" viewBox=\"0 0 16 16\">\n                    <path d=\"M11.354 1.646a.5.5 0 0 1 0 .708L5.707 8l5.647 5.646a.5.5 0 0 1-.708.708l-6-6a.5.5 0 0 1 0-.708l6-6a.5.5 0 0 1 .708 0z\"/>\n                </svg>\n                {{ step?.prevBtnTitle }}\n            </button>\n            <button\n                *ngIf=\"tourService.hasNext(step) && !step.nextOnAnchorClick\"\n                class=\"btn btn-sm btn-outline-primary next\"\n                (click)=\"tourService.next()\"\n            >\n                {{ step?.nextBtnTitle }}\n                <svg xmlns=\"http://www.w3.org/2000/svg\" width=\"16\" height=\"16\" fill=\"currentColor\" viewBox=\"0 0 16 16\">\n                    <path d=\"M4.646 1.646a.5.5 0 0 1 .708 0l6 6a.5.5 0 0 1 0 .708l-6 6a.5.5 0 0 1-.708-.708L10.293 8 4.646 2.354a.5.5 0 0 1 0-.708z\"/>\n                </svg>\n            </button>\n            <button\n                class=\"btn btn-sm btn-outline-primary\"\n                *ngIf=\"!tourService.hasNext(step)\"\n                (click)=\"tourService.end()\"\n            >\n                {{ step?.endBtnTitle }}\n            </button>\n        </div>\n    </div>\n</ng-template>\n", styles: ["::ng-deep .tour-step .popover-body{padding:0}.main-container{padding:.5rem 1rem .75rem}.title-container{display:flex;align-items:center;justify-content:space-between;margin-bottom:.5rem;gap:.25rem}.title-container h5{overflow:hidden;text-overflow:ellipsis;white-space:nowrap;margin-bottom:0;line-height:1.5}.buttons{display:flex;align-items:center;justify-content:space-between}.buttons .btn{display:flex;align-items:center;gap:.25rem}.buttons .btn.prev{padding-left:.25rem}.buttons .btn.next{padding-right:.25rem}\n"], dependencies: [{ kind: "directive", type: NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.1", ngImport: i0, type: TourStepTemplateComponent, decorators: [{
            type: Component,
            args: [{ selector: 'tour-step-template', standalone: true, imports: [
                        NgIf
                    ], template: "<ng-template #tourStep let-step=\"step\">\n    <div\n        [style.width]=\"step.stepDimensions?.width\"\n        [style.min-width]=\"step.stepDimensions?.minWidth\"\n        [style.max-width]=\"step.stepDimensions?.maxWidth\"\n        class=\"main-container\"\n    >\n        <div\n            *ngIf=\"!step?.useLegacyTitle && step?.title\"\n            class=\"title-container\"\n        >\n            <h5>{{step?.title}}</h5>\n            <button\n                type=\"button\"\n                class=\"btn-close\"\n                aria-label=\"Close\"\n                (click)=\"tourService.end()\"\n            ></button>\n        </div>\n\n        <p\n            class=\"card-text\"\n            [innerHTML]=\"step?.content\"\n        ></p>\n\n        <div class=\"buttons\">\n            <button\n                [disabled]=\"!tourService.hasPrev(step)\"\n                class=\"btn btn-sm btn-outline-secondary prev\"\n                (click)=\"tourService.prev()\"\n            >\n                <svg xmlns=\"http://www.w3.org/2000/svg\" width=\"16\" height=\"16\" fill=\"currentColor\" viewBox=\"0 0 16 16\">\n                    <path d=\"M11.354 1.646a.5.5 0 0 1 0 .708L5.707 8l5.647 5.646a.5.5 0 0 1-.708.708l-6-6a.5.5 0 0 1 0-.708l6-6a.5.5 0 0 1 .708 0z\"/>\n                </svg>\n                {{ step?.prevBtnTitle }}\n            </button>\n            <button\n                *ngIf=\"tourService.hasNext(step) && !step.nextOnAnchorClick\"\n                class=\"btn btn-sm btn-outline-primary next\"\n                (click)=\"tourService.next()\"\n            >\n                {{ step?.nextBtnTitle }}\n                <svg xmlns=\"http://www.w3.org/2000/svg\" width=\"16\" height=\"16\" fill=\"currentColor\" viewBox=\"0 0 16 16\">\n                    <path d=\"M4.646 1.646a.5.5 0 0 1 .708 0l6 6a.5.5 0 0 1 0 .708l-6 6a.5.5 0 0 1-.708-.708L10.293 8 4.646 2.354a.5.5 0 0 1 0-.708z\"/>\n                </svg>\n            </button>\n            <button\n                class=\"btn btn-sm btn-outline-primary\"\n                *ngIf=\"!tourService.hasNext(step)\"\n                (click)=\"tourService.end()\"\n            >\n                {{ step?.endBtnTitle }}\n            </button>\n        </div>\n    </div>\n</ng-template>\n", styles: ["::ng-deep .tour-step .popover-body{padding:0}.main-container{padding:.5rem 1rem .75rem}.title-container{display:flex;align-items:center;justify-content:space-between;margin-bottom:.5rem;gap:.25rem}.title-container h5{overflow:hidden;text-overflow:ellipsis;white-space:nowrap;margin-bottom:0;line-height:1.5}.buttons{display:flex;align-items:center;justify-content:space-between}.buttons .btn{display:flex;align-items:center;gap:.25rem}.buttons .btn.prev{padding-left:.25rem}.buttons .btn.next{padding-right:.25rem}\n"] }]
        }], propDecorators: { defaultTourStepTemplate: [{
                type: ViewChild,
                args: ['tourStep', { read: TemplateRef, static: true }]
            }], stepTemplate: [{
                type: Input
            }], stepTemplateContent: [{
                type: ContentChild,
                args: [TemplateRef]
            }] } });

const COMPONENTS = [TourAnchorNgBootstrapDirective, TourStepTemplateComponent];
class TourNgBootstrapModule {
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.1", ngImport: i0, type: TourNgBootstrapModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule }); }
    static { this.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "16.1.1", ngImport: i0, type: TourNgBootstrapModule, imports: [TourAnchorNgBootstrapDirective, TourStepTemplateComponent], exports: [TourAnchorNgBootstrapDirective, TourStepTemplateComponent] }); }
    static { this.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "16.1.1", ngImport: i0, type: TourNgBootstrapModule }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.1", ngImport: i0, type: TourNgBootstrapModule, decorators: [{
            type: NgModule,
            args: [{
                    imports: COMPONENTS,
                    exports: COMPONENTS
                }]
        }] });

/**
 * Generated bundle index. Do not edit.
 */

export { TourAnchorNgBootstrapDirective, TourNgBootstrapModule, NgbTourService as TourService, TourStepTemplateComponent };
//# sourceMappingURL=ngx-ui-tour-ng-bootstrap.mjs.map
